'''
这是一个8位计算机脉冲文件
--熊梓墨、熊鹰
'''

import machine,time

#手动clock
def single_clock(pin):
    hlt_value = hlt.value()
    two_one_value = clock_pin_two_one.value()
    if hlt_value == 1:
        if two_one_value == 1:
            clock_output_pin.on() 
            time.sleep_ms(300)
            clock_output_pin.off()
            time.sleep_ms(300)

#自动clock
def auto_clock(pin):
    hlt_value = hlt.value()
    while hlt_value == 1:
        two_one_value = clock_pin_two_one.value()
        hlt_value = hlt.value()
        if two_one_value == 0:
            a = clock_pin_auto_ADC.read()
            if a < 200 :
                clock_speed = 10
            else:
                clock_speed = 10 + int ((a - 200) ** 1.2)
            clock_output_pin.on()
            time.sleep_ms(clock_speed)
            clock_output_pin.off()
            time.sleep_ms(clock_speed)
        else:
            break

#定义脉冲pin
clock_output_pin = machine.Pin(15,machine.Pin.OUT)
#Hlt
hlt = machine.Pin(35,machine.Pin.IN)

#定义自动连续脉冲
clock_pin_auto = machine.Pin(36,machine.Pin.IN)
#定义单脉冲Pin
clock_pin_single = machine.Pin(34,machine.Pin.IN)
#定义二选一开关Pin
clock_pin_two_one = machine.Pin(39,machine.Pin.IN)


clock_pin_auto_ADC = machine.ADC(clock_pin_auto)
clock_pin_auto_ADC.atten(machine.ADC.ATTN_11DB)
clock_pin_auto_ADC.width(machine.ADC.WIDTH_9BIT)

clock_pin_single.irq(trigger = machine.Pin.IRQ_RISING, handler = single_clock)
clock_pin_two_one.irq(trigger = machine.Pin.IRQ_FALLING,handler = auto_clock)